require 'rake/rubygems'
require 'rubygems/gemcutter_utilities'
require 'rubygems/user_interaction'

$said = []

module Gem::UserInteraction
  def say(string)
    $said << string
  end
end

module Gem::GemcutterUtilities
  FakeRequest = Struct.new(:body)

  def rubygems_api_request(*args)
    return FakeRequest.new("Fake Request!  Ha!")
  end

  def with_response(resp)
  end
end

describe Rake::Gemcutter::Tasks do
  before do
    @spec = Gem::Specification.new
    @tasks = Rake::Gemcutter::Tasks.new(@spec)
  end
  it "should define gem:push" do
    Rake::Task['gem:push'].should_not be_nil
  end

  it "should successfully push the gem" do
    Rake::Task['gem:push'].execute.should be_true
  end

  it "should check for gem requirements" do
    @spec.add_dependency("rspec")
    Rake::Task['gem:dependencies_available'].execute.should be_true
  end

  it "should fail if gem requirements are missing" do
    @spec.add_dependency("True Love")
    expect do
      Rake::Task['gem:dependencies_available'].execute
    end.to raise_error
  end
end
